-- -------------------------------------------------------------
--
-- Module: Hbp4
--
-- Generated by MATLAB(R) 7.13 and the Filter Design HDL Coder 2.9.
--
-- Generated on: 2012-05-16 17:05:29
--
-- -------------------------------------------------------------

-- -------------------------------------------------------------
-- HDL Code Generation Options:
--
-- TargetLanguage: VHDL
-- OptimizeForHDL: on
-- HDLSynthTool: ISE
-- HDLSynthCmd: xfile add $src_dir/%s\n
-- HDLSynthFilePostfix: _ise.tcl
-- HDLSynthInit: set src_dir "/Volumes/Hades/Documents/Varsity/EEE4084F/YODA/DigitalEqualizer/hdlsrc"\nset prj_dir "synprj"\nfile mkdir ../$prj_dir\ncd ../$prj_dir\nproject new %s.ise\n
-- HDLSynthTerm: project set family Virtex4\nproject set device xc4vsx35\nproject set package ff668\nproject set speed -10\nprocess run "Synthesize - XST"
-- Name: Hbp4
-- TestBenchName: Hbp_tb
-- TestBenchStimulus: impulse step ramp chirp noise 

-- Filter Specifications:
--
-- Sampling Frequency   : 20 kHz
-- Response             : Bandpass
-- Specification        : N,Fst1,Fp1,Fp2,Fst2
-- Filter Order         : 20
-- First Stopband Edge  : 7.4 kHz
-- First Passband Edge  : 7.5 kHz
-- Second Passband Edge : 9.8 kHz
-- Second Stopband Edge : 9.9 kHz
-- -------------------------------------------------------------

-- -------------------------------------------------------------
-- HDL Implementation    : Fully parallel
-- Multipliers           : 21
-- Folding Factor        : 1
-- -------------------------------------------------------------
-- Filter Settings:
--
-- Discrete-Time FIR Filter (real)
-- -------------------------------
-- Filter Structure  : Direct-Form FIR
-- Filter Length     : 21
-- Stable            : Yes
-- Linear Phase      : Yes (Type 1)
-- Arithmetic        : fixed
-- Numerator         : s16,17 -> [-2.500000e-01 2.500000e-01)
-- Input             : s8,0 -> [-128 128)
-- Filter Internals  : Specify Precision
--   Output          : s8,0 -> [-128 128)
--   Product         : s32,29 -> [-4 4)
--   Accumulator     : s40,29 -> [-1024 1024)
--   Round Mode      : round
--   Overflow Mode   : saturate
-- -------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.numeric_std.ALL;
ENTITY Hbp4 IS
   PORT( clk                             :   IN    std_logic; 
         clk_enable                      :   IN    std_logic; 
         reset                           :   IN    std_logic; 
         filter_in                       :   IN    std_logic_vector(7 DOWNTO 0); -- sfix8
         filter_out                      :   OUT   std_logic_vector(7 DOWNTO 0)  -- sfix8
         );

END Hbp4;


----------------------------------------------------------------
--Module Architecture: Hbp4
----------------------------------------------------------------
ARCHITECTURE rtl OF Hbp4 IS
  -- Local Functions
  -- Type Definitions
  TYPE delay_pipeline_type IS ARRAY (NATURAL range <>) OF signed(7 DOWNTO 0); -- sfix8
  -- Constants
  CONSTANT coeff1                         : signed(15 DOWNTO 0) := to_signed(2537, 16); -- sfix16_En17
  CONSTANT coeff2                         : signed(15 DOWNTO 0) := to_signed(-2109, 16); -- sfix16_En17
  CONSTANT coeff3                         : signed(15 DOWNTO 0) := to_signed(-932, 16); -- sfix16_En17
  CONSTANT coeff4                         : signed(15 DOWNTO 0) := to_signed(5290, 16); -- sfix16_En17
  CONSTANT coeff5                         : signed(15 DOWNTO 0) := to_signed(-8470, 16); -- sfix16_En17
  CONSTANT coeff6                         : signed(15 DOWNTO 0) := to_signed(7892, 16); -- sfix16_En17
  CONSTANT coeff7                         : signed(15 DOWNTO 0) := to_signed(-2215, 16); -- sfix16_En17
  CONSTANT coeff8                         : signed(15 DOWNTO 0) := to_signed(-7779, 16); -- sfix16_En17
  CONSTANT coeff9                         : signed(15 DOWNTO 0) := to_signed(19251, 16); -- sfix16_En17
  CONSTANT coeff10                        : signed(15 DOWNTO 0) := to_signed(-28350, 16); -- sfix16_En17
  CONSTANT coeff11                        : signed(15 DOWNTO 0) := to_signed(31808, 16); -- sfix16_En17
  CONSTANT coeff12                        : signed(15 DOWNTO 0) := to_signed(-28350, 16); -- sfix16_En17
  CONSTANT coeff13                        : signed(15 DOWNTO 0) := to_signed(19251, 16); -- sfix16_En17
  CONSTANT coeff14                        : signed(15 DOWNTO 0) := to_signed(-7779, 16); -- sfix16_En17
  CONSTANT coeff15                        : signed(15 DOWNTO 0) := to_signed(-2215, 16); -- sfix16_En17
  CONSTANT coeff16                        : signed(15 DOWNTO 0) := to_signed(7892, 16); -- sfix16_En17
  CONSTANT coeff17                        : signed(15 DOWNTO 0) := to_signed(-8470, 16); -- sfix16_En17
  CONSTANT coeff18                        : signed(15 DOWNTO 0) := to_signed(5290, 16); -- sfix16_En17
  CONSTANT coeff19                        : signed(15 DOWNTO 0) := to_signed(-932, 16); -- sfix16_En17
  CONSTANT coeff20                        : signed(15 DOWNTO 0) := to_signed(-2109, 16); -- sfix16_En17
  CONSTANT coeff21                        : signed(15 DOWNTO 0) := to_signed(2537, 16); -- sfix16_En17

  -- Signals
  SIGNAL delay_pipeline                   : delay_pipeline_type(0 TO 20); -- sfix8
  SIGNAL product21                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp                         : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product20                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_1                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product19                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_2                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product18                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_3                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product17                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_4                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product16                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_5                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product15                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_6                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product14                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_7                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product13                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_8                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product12                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_9                       : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product11                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_10                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product10                        : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_11                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product9                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_12                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product8                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_13                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product7                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_14                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product6                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_15                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product5                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_16                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product4                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_17                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product3                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_18                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product2                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_19                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL product1                         : signed(31 DOWNTO 0); -- sfix32_En29
  SIGNAL mul_temp_20                      : signed(23 DOWNTO 0); -- sfix24_En17
  SIGNAL sum1                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp                         : signed(32 DOWNTO 0); -- sfix33_En29
  SIGNAL sum2                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_1                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum3                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_2                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum4                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_3                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum5                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_4                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum6                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_5                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum7                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_6                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum8                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_7                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum9                             : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_8                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum10                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_9                       : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum11                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_10                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum12                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_11                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum13                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_12                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum14                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_13                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum15                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_14                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum16                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_15                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum17                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_16                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum18                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_17                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum19                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_18                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL sum20                            : signed(39 DOWNTO 0); -- sfix40_En29
  SIGNAL add_temp_19                      : signed(40 DOWNTO 0); -- sfix41_En29
  SIGNAL output_typeconvert               : signed(7 DOWNTO 0); -- sfix8
  SIGNAL output_register                  : signed(7 DOWNTO 0); -- sfix8


BEGIN

  -- Block Statements
  Delay_Pipeline_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      delay_pipeline(0 TO 20) <= (OTHERS => (OTHERS => '0'));
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        delay_pipeline(0) <= signed(filter_in);
        delay_pipeline(1 TO 20) <= delay_pipeline(0 TO 19);
      END IF;
    END IF; 
  END PROCESS Delay_Pipeline_process;


  mul_temp <= delay_pipeline(20) * coeff21;
  product21 <= (31 => '0', OTHERS => '1') WHEN mul_temp(23) = '0' AND mul_temp(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp(23) = '1' AND mul_temp(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_1 <= delay_pipeline(19) * coeff20;
  product20 <= (31 => '0', OTHERS => '1') WHEN mul_temp_1(23) = '0' AND mul_temp_1(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_1(23) = '1' AND mul_temp_1(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_1 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_2 <= delay_pipeline(18) * coeff19;
  product19 <= (31 => '0', OTHERS => '1') WHEN mul_temp_2(23) = '0' AND mul_temp_2(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_2(23) = '1' AND mul_temp_2(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_2 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_3 <= delay_pipeline(17) * coeff18;
  product18 <= (31 => '0', OTHERS => '1') WHEN mul_temp_3(23) = '0' AND mul_temp_3(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_3(23) = '1' AND mul_temp_3(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_3 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_4 <= delay_pipeline(16) * coeff17;
  product17 <= (31 => '0', OTHERS => '1') WHEN mul_temp_4(23) = '0' AND mul_temp_4(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_4(23) = '1' AND mul_temp_4(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_4 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_5 <= delay_pipeline(15) * coeff16;
  product16 <= (31 => '0', OTHERS => '1') WHEN mul_temp_5(23) = '0' AND mul_temp_5(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_5(23) = '1' AND mul_temp_5(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_5 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_6 <= delay_pipeline(14) * coeff15;
  product15 <= (31 => '0', OTHERS => '1') WHEN mul_temp_6(23) = '0' AND mul_temp_6(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_6(23) = '1' AND mul_temp_6(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_6 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_7 <= delay_pipeline(13) * coeff14;
  product14 <= (31 => '0', OTHERS => '1') WHEN mul_temp_7(23) = '0' AND mul_temp_7(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_7(23) = '1' AND mul_temp_7(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_7 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_8 <= delay_pipeline(12) * coeff13;
  product13 <= (31 => '0', OTHERS => '1') WHEN mul_temp_8(23) = '0' AND mul_temp_8(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_8(23) = '1' AND mul_temp_8(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_8 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_9 <= delay_pipeline(11) * coeff12;
  product12 <= (31 => '0', OTHERS => '1') WHEN mul_temp_9(23) = '0' AND mul_temp_9(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_9(23) = '1' AND mul_temp_9(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_9 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_10 <= delay_pipeline(10) * coeff11;
  product11 <= (31 => '0', OTHERS => '1') WHEN mul_temp_10(23) = '0' AND mul_temp_10(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_10(23) = '1' AND mul_temp_10(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_10 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_11 <= delay_pipeline(9) * coeff10;
  product10 <= (31 => '0', OTHERS => '1') WHEN mul_temp_11(23) = '0' AND mul_temp_11(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_11(23) = '1' AND mul_temp_11(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_11 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_12 <= delay_pipeline(8) * coeff9;
  product9 <= (31 => '0', OTHERS => '1') WHEN mul_temp_12(23) = '0' AND mul_temp_12(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_12(23) = '1' AND mul_temp_12(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_12 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_13 <= delay_pipeline(7) * coeff8;
  product8 <= (31 => '0', OTHERS => '1') WHEN mul_temp_13(23) = '0' AND mul_temp_13(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_13(23) = '1' AND mul_temp_13(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_13 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_14 <= delay_pipeline(6) * coeff7;
  product7 <= (31 => '0', OTHERS => '1') WHEN mul_temp_14(23) = '0' AND mul_temp_14(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_14(23) = '1' AND mul_temp_14(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_14 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_15 <= delay_pipeline(5) * coeff6;
  product6 <= (31 => '0', OTHERS => '1') WHEN mul_temp_15(23) = '0' AND mul_temp_15(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_15(23) = '1' AND mul_temp_15(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_15 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_16 <= delay_pipeline(4) * coeff5;
  product5 <= (31 => '0', OTHERS => '1') WHEN mul_temp_16(23) = '0' AND mul_temp_16(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_16(23) = '1' AND mul_temp_16(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_16 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_17 <= delay_pipeline(3) * coeff4;
  product4 <= (31 => '0', OTHERS => '1') WHEN mul_temp_17(23) = '0' AND mul_temp_17(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_17(23) = '1' AND mul_temp_17(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_17 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_18 <= delay_pipeline(2) * coeff3;
  product3 <= (31 => '0', OTHERS => '1') WHEN mul_temp_18(23) = '0' AND mul_temp_18(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_18(23) = '1' AND mul_temp_18(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_18 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_19 <= delay_pipeline(1) * coeff2;
  product2 <= (31 => '0', OTHERS => '1') WHEN mul_temp_19(23) = '0' AND mul_temp_19(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_19(23) = '1' AND mul_temp_19(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_19 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  mul_temp_20 <= delay_pipeline(0) * coeff1;
  product1 <= (31 => '0', OTHERS => '1') WHEN mul_temp_20(23) = '0' AND mul_temp_20(22 DOWNTO 19) /= "0000"
      ELSE (31 => '1', OTHERS => '0') WHEN mul_temp_20(23) = '1' AND mul_temp_20(22 DOWNTO 19) /= "1111"
      ELSE (resize(mul_temp_20 & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0' & '0', 32));

  add_temp <= resize(product1, 33) + resize(product2, 33);
  sum1 <= resize(add_temp, 40);

  add_temp_1 <= resize(sum1, 41) + resize(product3, 41);
  sum2 <= (39 => '0', OTHERS => '1') WHEN (add_temp_1(40) = '0' AND add_temp_1(39) /= '0') OR (add_temp_1(40) = '0' AND add_temp_1(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_1(40) = '1' AND add_temp_1(39) /= '1'
      ELSE (add_temp_1(39 DOWNTO 0));

  add_temp_2 <= resize(sum2, 41) + resize(product4, 41);
  sum3 <= (39 => '0', OTHERS => '1') WHEN (add_temp_2(40) = '0' AND add_temp_2(39) /= '0') OR (add_temp_2(40) = '0' AND add_temp_2(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_2(40) = '1' AND add_temp_2(39) /= '1'
      ELSE (add_temp_2(39 DOWNTO 0));

  add_temp_3 <= resize(sum3, 41) + resize(product5, 41);
  sum4 <= (39 => '0', OTHERS => '1') WHEN (add_temp_3(40) = '0' AND add_temp_3(39) /= '0') OR (add_temp_3(40) = '0' AND add_temp_3(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_3(40) = '1' AND add_temp_3(39) /= '1'
      ELSE (add_temp_3(39 DOWNTO 0));

  add_temp_4 <= resize(sum4, 41) + resize(product6, 41);
  sum5 <= (39 => '0', OTHERS => '1') WHEN (add_temp_4(40) = '0' AND add_temp_4(39) /= '0') OR (add_temp_4(40) = '0' AND add_temp_4(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_4(40) = '1' AND add_temp_4(39) /= '1'
      ELSE (add_temp_4(39 DOWNTO 0));

  add_temp_5 <= resize(sum5, 41) + resize(product7, 41);
  sum6 <= (39 => '0', OTHERS => '1') WHEN (add_temp_5(40) = '0' AND add_temp_5(39) /= '0') OR (add_temp_5(40) = '0' AND add_temp_5(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_5(40) = '1' AND add_temp_5(39) /= '1'
      ELSE (add_temp_5(39 DOWNTO 0));

  add_temp_6 <= resize(sum6, 41) + resize(product8, 41);
  sum7 <= (39 => '0', OTHERS => '1') WHEN (add_temp_6(40) = '0' AND add_temp_6(39) /= '0') OR (add_temp_6(40) = '0' AND add_temp_6(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_6(40) = '1' AND add_temp_6(39) /= '1'
      ELSE (add_temp_6(39 DOWNTO 0));

  add_temp_7 <= resize(sum7, 41) + resize(product9, 41);
  sum8 <= (39 => '0', OTHERS => '1') WHEN (add_temp_7(40) = '0' AND add_temp_7(39) /= '0') OR (add_temp_7(40) = '0' AND add_temp_7(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_7(40) = '1' AND add_temp_7(39) /= '1'
      ELSE (add_temp_7(39 DOWNTO 0));

  add_temp_8 <= resize(sum8, 41) + resize(product10, 41);
  sum9 <= (39 => '0', OTHERS => '1') WHEN (add_temp_8(40) = '0' AND add_temp_8(39) /= '0') OR (add_temp_8(40) = '0' AND add_temp_8(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_8(40) = '1' AND add_temp_8(39) /= '1'
      ELSE (add_temp_8(39 DOWNTO 0));

  add_temp_9 <= resize(sum9, 41) + resize(product11, 41);
  sum10 <= (39 => '0', OTHERS => '1') WHEN (add_temp_9(40) = '0' AND add_temp_9(39) /= '0') OR (add_temp_9(40) = '0' AND add_temp_9(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_9(40) = '1' AND add_temp_9(39) /= '1'
      ELSE (add_temp_9(39 DOWNTO 0));

  add_temp_10 <= resize(sum10, 41) + resize(product12, 41);
  sum11 <= (39 => '0', OTHERS => '1') WHEN (add_temp_10(40) = '0' AND add_temp_10(39) /= '0') OR (add_temp_10(40) = '0' AND add_temp_10(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_10(40) = '1' AND add_temp_10(39) /= '1'
      ELSE (add_temp_10(39 DOWNTO 0));

  add_temp_11 <= resize(sum11, 41) + resize(product13, 41);
  sum12 <= (39 => '0', OTHERS => '1') WHEN (add_temp_11(40) = '0' AND add_temp_11(39) /= '0') OR (add_temp_11(40) = '0' AND add_temp_11(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_11(40) = '1' AND add_temp_11(39) /= '1'
      ELSE (add_temp_11(39 DOWNTO 0));

  add_temp_12 <= resize(sum12, 41) + resize(product14, 41);
  sum13 <= (39 => '0', OTHERS => '1') WHEN (add_temp_12(40) = '0' AND add_temp_12(39) /= '0') OR (add_temp_12(40) = '0' AND add_temp_12(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_12(40) = '1' AND add_temp_12(39) /= '1'
      ELSE (add_temp_12(39 DOWNTO 0));

  add_temp_13 <= resize(sum13, 41) + resize(product15, 41);
  sum14 <= (39 => '0', OTHERS => '1') WHEN (add_temp_13(40) = '0' AND add_temp_13(39) /= '0') OR (add_temp_13(40) = '0' AND add_temp_13(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_13(40) = '1' AND add_temp_13(39) /= '1'
      ELSE (add_temp_13(39 DOWNTO 0));

  add_temp_14 <= resize(sum14, 41) + resize(product16, 41);
  sum15 <= (39 => '0', OTHERS => '1') WHEN (add_temp_14(40) = '0' AND add_temp_14(39) /= '0') OR (add_temp_14(40) = '0' AND add_temp_14(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_14(40) = '1' AND add_temp_14(39) /= '1'
      ELSE (add_temp_14(39 DOWNTO 0));

  add_temp_15 <= resize(sum15, 41) + resize(product17, 41);
  sum16 <= (39 => '0', OTHERS => '1') WHEN (add_temp_15(40) = '0' AND add_temp_15(39) /= '0') OR (add_temp_15(40) = '0' AND add_temp_15(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_15(40) = '1' AND add_temp_15(39) /= '1'
      ELSE (add_temp_15(39 DOWNTO 0));

  add_temp_16 <= resize(sum16, 41) + resize(product18, 41);
  sum17 <= (39 => '0', OTHERS => '1') WHEN (add_temp_16(40) = '0' AND add_temp_16(39) /= '0') OR (add_temp_16(40) = '0' AND add_temp_16(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_16(40) = '1' AND add_temp_16(39) /= '1'
      ELSE (add_temp_16(39 DOWNTO 0));

  add_temp_17 <= resize(sum17, 41) + resize(product19, 41);
  sum18 <= (39 => '0', OTHERS => '1') WHEN (add_temp_17(40) = '0' AND add_temp_17(39) /= '0') OR (add_temp_17(40) = '0' AND add_temp_17(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_17(40) = '1' AND add_temp_17(39) /= '1'
      ELSE (add_temp_17(39 DOWNTO 0));

  add_temp_18 <= resize(sum18, 41) + resize(product20, 41);
  sum19 <= (39 => '0', OTHERS => '1') WHEN (add_temp_18(40) = '0' AND add_temp_18(39) /= '0') OR (add_temp_18(40) = '0' AND add_temp_18(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_18(40) = '1' AND add_temp_18(39) /= '1'
      ELSE (add_temp_18(39 DOWNTO 0));

  add_temp_19 <= resize(sum19, 41) + resize(product21, 41);
  sum20 <= (39 => '0', OTHERS => '1') WHEN (add_temp_19(40) = '0' AND add_temp_19(39) /= '0') OR (add_temp_19(40) = '0' AND add_temp_19(39 DOWNTO 0) = "0111111111111111111111111111111111111111") -- special case0
      ELSE (39 => '1', OTHERS => '0') WHEN add_temp_19(40) = '1' AND add_temp_19(39) /= '1'
      ELSE (add_temp_19(39 DOWNTO 0));

  output_typeconvert <= (7 => '0', OTHERS => '1') WHEN (sum20(39) = '0' AND sum20(38 DOWNTO 36) /= "000") OR (sum20(39) = '0' AND sum20(36 DOWNTO 29) = "01111111") -- special case0
      ELSE (7 => '1', OTHERS => '0') WHEN sum20(39) = '1' AND sum20(38 DOWNTO 36) /= "111"
      ELSE (resize(shift_right(sum20(39) & sum20(36 DOWNTO 0) + ( "0" & ( NOT sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39) & sum20(39))), 29), 8));

  Output_Register_process : PROCESS (clk, reset)
  BEGIN
    IF reset = '1' THEN
      output_register <= (OTHERS => '0');
    ELSIF clk'event AND clk = '1' THEN
      IF clk_enable = '1' THEN
        output_register <= output_typeconvert;
      END IF;
    END IF; 
  END PROCESS Output_Register_process;

  -- Assignment Statements
  filter_out <= std_logic_vector(output_register);
END rtl;
