-- Vhdl test bench created from schematic C:\Documents and Settings\FilterBank\Padawan.sch - Thu May 17 05:04:27 2012
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
--use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY Padawan_Padawan_sch_tb IS
END Padawan_Padawan_sch_tb;
ARCHITECTURE behavioral OF Padawan_Padawan_sch_tb IS 

   COMPONENT Padawan
   PORT( Enable	:	IN	STD_LOGIC; 
          Clock	:	IN	STD_LOGIC; 
          Data_out	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          Data_in	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0));
   END COMPONENT;

   SIGNAL Enable	:	STD_LOGIC;
   SIGNAL Clock	:	STD_LOGIC;
   SIGNAL Data_out	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL Data_in	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
	
	signal dat : std_logic_vector (7 downto 0) := x"00";
	
	constant clk_period : time := 20 ns;

BEGIN

   UUT: Padawan PORT MAP(
		Enable => Enable, 
		Clock => Clock, 
		Data_out => Data_out, 
		Data_in => Data_in
   );
	
	clk_process :process
   begin
		Clock <= '0';
		wait for clk_period/2;
		Clock <= '1';
		wait for clk_period/2;
   end process;

-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
		-- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clk_period*10;
		
		Enable <= '1';
		
		for i in 0 to 2047 loop
			Data_in <= dat;
			dat <= dat + '1';
			wait for 10 ns;
		end loop;
	
      WAIT; -- will wait forever
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
