--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   19:10:02 05/16/2012
-- Design Name:   
-- Module Name:   C:/Documents and Settings/FilterBank/filterbank_tb.vhd
-- Project Name:  FilterBank
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: filterbank
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
USE ieee.numeric_std.ALL;
--use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


 
ENTITY filterbank_tb IS
END filterbank_tb;
 
ARCHITECTURE behavior OF filterbank_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT filterbank
    PORT(
         clk : IN  std_logic;
         addr_start : IN  std_logic_vector(7 downto 0);
         done : IN  std_logic;
         mem_in_addr : OUT  std_logic_vector(7 downto 0);
         data_in : IN  std_logic_vector(7 downto 0);
         data_in_ready : IN  std_logic;
         mem_out_addr : OUT  std_logic_vector(9 downto 0);
         data_out : OUT  std_logic_vector(7 downto 0);
         output_buffer_done : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal addr_start : std_logic_vector(7 downto 0) := (others => '0');
   signal done : std_logic := '0';
   signal data_in : std_logic_vector(7 downto 0) := (others => '0');
   signal data_in_ready : std_logic := '0';

 	--Outputs
   signal mem_in_addr : std_logic_vector(7 downto 0) := (others => '1');

   signal mem_out_addr : std_logic_vector(9 downto 0):= (others => '0');
   signal data_out : std_logic_vector(7 downto 0):= (others => '0');
   signal output_buffer_done : std_logic := '0';

   -- Clock period definitions
   constant clk_period : time := 10 ns;
	
	-- Simulation variables
	type arr is array(0 to 1023) of std_logic_vector(7 downto 0);
	signal memory : arr;
	
	signal dat : std_logic_vector (7 downto 0) := x"00";
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: filterbank PORT MAP (
          clk => clk,
          addr_start => addr_start,
          done => done,
          mem_in_addr => mem_in_addr,
          data_in => data_in,
          data_in_ready => data_in_ready,
          mem_out_addr => mem_out_addr,
          data_out => data_out,
          output_buffer_done => output_buffer_done
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clk_period*10;

      -- insert stimulus here
		done <= '0';
		
		-- Load memory with dome data
		for i in 0 to 1023 loop
			memory(i) <= dat;
			dat <= dat + '1';
			wait for 10 ns;
		end loop;
		
		-- Set the start address
		addr_start <= x"01";
		wait for 12 ns;
		
		-- Now set done to high
		done <=  '1';
		
		wait for clk_period;
		 
		done <= '0';
			

	 
		for i in 0 to 255 loop
			data_in <= memory(to_integer(unsigned(mem_in_addr)));
			data_in_ready <= '1';
			wait for 5 ns;
			data_in_ready <= '0';
			wait for 5 ns;
		end loop;

		-- Now try read the data
		
      wait;
   end process;

END;
