----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:56:54 05/16/2012 
-- Design Name: 
-- Module Name:    outBuffer - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
--USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity outBuffer is
    Port ( dReady : in  STD_LOGIC;
           addrStart : in  STD_LOGIC_VECTOR (9 downto 0);
           done : in  STD_LOGIC;
			  clk : in STD_LOGIC;
			  dataRead : in STD_LOGIC_VECTOR(7 downto 0);
           addrRead : out  STD_LOGIC_VECTOR (9 downto 0);
           outSample : out  STD_LOGIC_VECTOR (7 downto 0));
end outBuffer;

architecture Behavioral of outBuffer is

type ram_type IS ARRAY(0 to 511) OF STD_LOGIC_VECTOR(7 downto 0);
type smallBuf IS ARRAY(0 to 127) OF STD_LOGIC_VECTOR(7 downto 0);

signal dataOut : ram_type;
signal tmpAddr : STD_LOGIC_VECTOR(9 downto 0);
signal cnt : STD_LOGIC_VECTOR(8 downto 0) := "000000000";
signal outTrig : STD_LOGIC := '0';

begin

		process(done, dReady, outTrig, clk)
		begin
			if (done'event and done = '1') then				
				tmpAddr <= addrStart;
				cnt <= "000000000";
			end if;
			
			if (dReady'event and dReady = '1') then
				
				dataOut(to_integer(unsigned(cnt))) <= dataRead;
			
				cnt <= std_logic_vector(unsigned(cnt) + 1);
				
				if (cnt < "111111111") then
					tmpAddr <= std_logic_vector(unsigned(tmpAddr) + 1);
				else 
					cnt <= "000000000";
					outTrig <= '1';
				end if;				
				
			end if;
			
			if (clk = '1' and clk'event and outTrig = '1') then
			
				outSample <= std_logic_vector( unsigned( SHR(dataOut(to_integer(unsigned(cnt))),"10") ) + unsigned( SHR(dataOut(to_integer(unsigned(cnt + x"80"))),"10") )  + unsigned( SHR(dataOut(to_integer(unsigned(cnt + x"100"))),"10") )  + unsigned( SHR(dataOut(to_integer(unsigned(cnt + x"180"))),"10") ) );
				cnt <= std_logic_vector(unsigned(cnt) + 1);
				
				if (cnt = "001111111") then
					outTrig <= '0';
				end if;			
			end if;
			
			addrRead <= tmpAddr;
		end process;
		
end Behavioral;

