Fpass = 0.45; % Passband Frequency
Fstop = 0.55; % Stopband Frequency
Apass = 1;    % Passband Attenuation (dB)
Astop = 60;   % Stopband Attenuation (dB)

f = fdesign.lowpass('Fp,Fst,Ap,Ast',Fpass,Fstop,Apass,Astop);
Hlp = design(f, 'equiripple','FilterStructure', 'dffir'); % Lowpass

Hhp = firlp2hp(Hlp);                                      % Highpass

f1 = fdesign.bandpass('N,Fst1,Fp1,Fp2,Fst2', 20, 10, 20, 2500, 2600, 20000);
designmethods(f1);
H1 = design(f1, 'firls');

f2 = fdesign.bandpass('N,Fst1,Fp1,Fp2,Fst2', 20, 2400, 2500, 5000, 5100, 20000);
designmethods(f2);
H2 = design(f2, 'firls');

f3 = fdesign.bandpass('N,Fst1,Fp1,Fp2,Fst2', 20, 4900, 5000, 7500, 7600, 20000);
designmethods(f3);
H3 = design(f3, 'firls');

f4 = fdesign.bandpass('N,Fst1,Fp1,Fp2,Fst2', 20, 7400, 7500, 9800, 9900, 20000);
designmethods(f4);
H4 = design(f4, 'firls');

for Hlp = [H1, H2, H3, H4]
    Hlp.Arithmetic = 'fixed';
    Hlp.InputWordLength = 8;
    Hlp.InputFracLength = 7;
    specifyall(Hlp);
    Hlp.OutputWordLength = 8;
    Hlp.OutputFracLength = 7;
    Hlp.CoeffWordLength = 8;
    Hlp.CoeffAutoScale = false;
    Hlp.NumFracLength = 7; 
end

